unit DCUDefs;

interface

const
    // Magic signatures

    D2Magic  =         $50505348;
    D3Magic  =         $44518641;
    D4Magic  =         $4768A6D8;
    D5Magic  =         $F21F148B;
    B3Magic  =         $475896C8;

    // DCU record tags

    Tag_Variable      =        $20;       // variable definition
    Tag_Param         =        $21;       // parameter definition
    Tag_VarPar	      =        $22;	  // VAR parameter definition
    Tag_ResPtr        =        $23;
    Tag_AbsVar	      =        $24;
    Tag_Const         =        $25;       // constant definition
    Tag_VMT           =        $26;       // VMT definition
    Tag_StructConst   =        $27;       // Typed constant definition
    Tag_Proc          =        $28;       // procedure definition
    Tag_StdProc       =        $29;       // stdproc definition
    Tag_Type          =        $2A;       // type definition
    Tag_Label	      =        $2B;	  // label definition
    Tag_Field	      =        $2C;
    Tag_Method        =        $2D;
    Tag_Constructor   =        $2E;
    Tag_Destructor    =        $2F;
    Tag_Property      =        $30;
    Tag_ThreadVar     =        $31;       // thread variable definition
    Tag_ResString     =        $32;	  // resource string definition
    Tag_ExtProc       =        $33;

    Tag_End           =        $61;       // end of file marker
    Tag_End_Record    =	       $63;       // end of compound record
    Tag_Int_Use	      =	       $64;       // external definitions used by INTERFACE
    Tag_Imp_Use	      =	       $65;       // external definitions used by IMPLEMENTATION
    Tag_Type_Use      =        $66;       // reference to external type
    Tag_Sym_Use       =        $67;       // reference to external symbol
    Tag_DLL_Import    =        $68;       // reference to DLL-imports
    Tag_Inc_Level     =        $6A;       // increment level
    Tag_Dec_Level     =        $6B;       // decrement level

    Tag_DFK_Source    =        $70;       // required Source file (.PAS / .INC)
    Tag_DFK_Object    =	       $71;       // required Source file (.OBJ)
    Tag_DFK_Resource  =	       $72;       // required Source file (.RES)
    Tag_DFK_TheAdr    =	       $73;       // required Source file (.???)

    Tag_Unit_Flags    =        $96;       // unit flags information

type
    TDCUVersion = ( B3, D2, D3, D4, D5 );

implementation

end.
